/* $Id: aomidctl.h 322 2010-01-14 06:37:17Z ken $ */
/*
 * Copyright (c) 2009 KAMADA Ken'ichi.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

struct ctl_msg_header {
	uint8_t version;
	uint8_t command;
	uint16_t reserved;
};

#define CTL_OK			0
#define CTL_EBADCMD		1

#define CTL_RELOAD		16
#define CTL_STAT		17

struct ctl_msg_generic {
	struct ctl_msg_header h;
};

struct ctl_msg_rep_stat {
	struct ctl_msg_header h;
	uint32_t d_query;
	uint32_t d_success;
	uint32_t d_nodata;
	uint32_t d_nxdomain;
	uint32_t d_servfail;
	uint32_t obj_pbuf_req;
	uint32_t obj_pbuf_rel;
	uint32_t obj_pbuf_fail;
	uint32_t obj_pbuf_max;
	uint32_t obj_udpsock_req;
	uint32_t obj_udpsock_rel;
	uint32_t obj_udpsock_fail;
	uint32_t obj_udpsock_max;
	uint32_t obj_tcpsock_req;
	uint32_t obj_tcpsock_rel;
	uint32_t obj_tcpsock_fail;
	uint32_t obj_tcpsock_max;
	uint32_t obj_qtask_req;
	uint32_t obj_qtask_rel;
	uint32_t obj_qtask_fail;
	uint32_t obj_qtask_max;
};
