/* $Id: cache.h 201 2007-10-24 14:11:50Z ken $ */
/*
 * Copyright (c) 2006 KAMADA Ken'ichi.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/* XXX how to cache UDP/TCP errors, etc */
struct cache {
	time_t eol;
	struct cache *next;
	void (*destructor)(struct cache *c);
};

struct cacheref {
	unsigned int generation;
	struct cache *c;
};

int c_init(size_t size);
void *c_new(size_t len);
void *c_extcpy(const void *ptr, size_t len);
void *c_extcpy_align(const void *ptr, size_t len);
void c_checkttl(struct cache *c, uint32_t ttl);
void c_bumptime(void);

#ifdef NOTUSED
void c_refer(struct cacheref *cr, struct cache *c);
int c_isvalid(struct cacheref *cr);
#endif

void cache_expired(struct cache *c);
void cache_replaced(struct cache *c);

void info_cache(void);

/* To provide the same time when parsing a packet and searching in the cache. */
extern time_t curtime;
