/* $Id: clock_gettime.c 227 2007-12-14 01:24:36Z ken $ */
/*
 * This code was written by KAMADA Ken'ichi, and in the public domain.
 *
 * XXX This does NOT implement the correct semantics of clock_id.
 */

#include <sys/time.h>
#include <errno.h>
#include <time.h>

#include "missing.h"

int
clock_gettime(clockid_t clock_id, struct timespec *tp)
{
	struct timeval tv;

	switch (clock_id) {
	case CLOCK_REALTIME:
	case CLOCK_MONOTONIC:
		if (gettimeofday(&tv, NULL) == -1)
			return -1;
		tp->tv_sec = tv.tv_sec;
		tp->tv_nsec = tv.tv_usec * 1000L;
		return 0;
	default:
		errno = EINVAL;
		return -1;
	}
}
