/* $Id: stats.c 320 2010-01-14 05:52:15Z ken $ */
/*
 * Copyright (c) 2006 KAMADA Ken'ichi.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <sys/types.h>
#include <syslog.h>

#include "util.h"
#include "stats.h"

struct stats stats;

void
init_stats(void)
{
	static const struct stats stats0;

	stats = stats0;
}

void
info_stats(void)
{
	LINFO("Stat:");
#define D(field) LINFO(" " #field " = %d", stats.field)
#undef D
	LINFO(" query=%u, success=%u, nodata=%u, nxdomain=%u, servfail=%u",
	    stats.d_query, stats.d_success, stats.d_nodata,
	    stats.d_nxdomain, stats.d_servfail);
	LINFO(" pbuf requested=%u, released=%u, failed=%u, max=%u",
	    stats.obj_pbuf_alloc + stats.obj_pbuf_fail,
	    stats.obj_pbuf_alloc - stats.obj_pbuf,
	    stats.obj_pbuf_fail, stats.obj_pbuf_max);
	LINFO(" udpsock requested=%u, released=%u, failed=%u, max=%u",
	    stats.obj_udpsock_alloc + stats.obj_udpsock_fail,
	    stats.obj_udpsock_alloc - stats.obj_udpsock,
	    stats.obj_udpsock_fail, stats.obj_udpsock_max);
	LINFO(" tcpsock requested=%u, released=%u, failed=%u, max=%u",
	    stats.obj_tcpsock_alloc + stats.obj_tcpsock_fail,
	    stats.obj_tcpsock_alloc - stats.obj_tcpsock,
	    stats.obj_tcpsock_fail, stats.obj_tcpsock_max);
	LINFO(" qtask requested=%u, released=%u, failed=%u, max=%u",
	    stats.obj_qtask_alloc + stats.obj_qtask_fail,
	    stats.obj_qtask_alloc - stats.obj_qtask,
	    stats.obj_qtask_fail, stats.obj_qtask_max);
	LINFO(" cache expired=%u, replaced=%u, reclaimed=%u, wasted=%u",
	    stats.cache_expired, stats.cache_replaced, stats.cache_reclaimed,
	    stats.cache_wasted);
}
